#include <algorithm>
#include <fstream>
#include <math.h>
#include <list>

#define MAX_PNTs 1002
#define MAX_DIST 999999
#define NOT_FOUND -1

#define DEBUG

using namespace std;

ifstream in ("input.txt");
ofstream out("output.txt");
ofstream dbg("debug.txt");

list <double> lengths;				//    ""   M [ min(L, M-L) ]

double	A[MAX_PNTs][MAX_PNTs];		//    
double	pnt[2][MAX_PNTs];			//   "" ([x][i], [y][i]) - X  Y  
double	M;							//   
int		Y, N;						//   (    ),  .
double	dist[2][MAX_PNTs];			// 2-  ( ).  [0] -       
int		mark[2][MAX_PNTs];			// 2-  ( ""  ) -  
double	best_dist, best_L;			//   ,  "" (  - L)

/* --------------------------------------------  DEBUG' ----------------------------------------------- */
int		pred[2][MAX_PNTs];			//        [   ][]
int		pred_log[2][MAX_PNTs];		//  -         
/* -------------------------------------------------------------------------------------------------------- */

void file_read()
{
	in >> Y >> M >> N;
	N++;							//   2   {0} -   , {N} -   
	for(int i = 1; i < N; i++)		//  {0} [1...N-1] {N}
	{
		in >> pnt[0][i];			// x - 
		in >> pnt[1][i];			// y - 
	}
}

double count_dist(int i, int j)						//      [i][j]
{
	double delt_X = pnt[0][i] - pnt[0][j];
	double delt_Y = pnt[1][i] - pnt[1][j];

	return sqrt( (delt_X*delt_X) + (delt_Y*delt_Y) );
}

void len_insert(double d)							//   ""    (  )
{
	lengths.insert(lower_bound(lengths.begin(), lengths.end(), d), d);
}

void fill_dist_matrix()
{
	double d;

	for(int i = 0; i <= N; i++)
		for(int j = 0; j <= N; j++)
			A[i][j] = MAX_DIST;

	for(int i = 1; i < N; i++)						//     {0}  {N} 
	{
		d = pnt[1][i];								// y -   (=   {0} )
		if( d < M )									//         {0}
		{
			A[0][i] = A[i][0] = d;
			if( d <= M/2 )	len_insert(d);			//   ""  
			else			len_insert(M-d);		// min( d, M-d )
		}

		d = Y - pnt[1][i];							//     {N}

		if( d < M )
		{
			A[N][i] = A[i][N] = d;
			if( d <= M/2 )	len_insert(d);
			else			len_insert(M-d);
		}
	}

	for(int i = 1; i < N; i++)
		for(int j = 1; j < N; j++)
		{
			if( i == j ) continue;					// A[i][i] = MAX_DIST  
			d = count_dist(i, j);
			if( d  <  M  ) 
			{
				A[i][j] = A[j][i] = d;
				if( d <= M/2 )	len_insert(d);
				else			len_insert(M-d);
			}
		}
}

/* --------------------------------------------  DEBUG' ----------------------------------------------- */
#ifdef DEBUG
	void show_matrix()							//   
	{
		for(int i = 0; i <= N; i++)
		{
			for(int j = 0; j <= N; j++)
			{
				dbg.width(10);
				dbg << "A[" << i << "][" << j << "]: ";
				dbg.width(9);
				if( A[i][j] == MAX_DIST )	dbg << "       MAX";
				else						dbg << A[i][j] << " ";
			}
			dbg << endl;
		}
		
		dbg << endl << "Lengthes : ";			//    "" 

		for(list<double>::iterator L_ptr = lengths.begin(); L_ptr != lengths.end(); L_ptr++)
		{
			dbg << *L_ptr << " ";
		}
		dbg << endl << endl;
	}

	void write_path(int t, int l)				//       [t]   [l]
	{
		if( t != 0 ) write_path(pred[l][t], pred_log[l][t]);
		dbg << t << ( l ? " - K - " : " - L - " );
	}
#endif
/* -------------------------------------------------------------------------------------------------------- */

int get_min(int* len)								//  ""  
{
	int		v	= NOT_FOUND;
	double	min	= MAX_DIST;

	for(int i = 0; i < 2; i++)						//    (   L  )
		for(int j = 0; j <= N; j++)
			if( !mark[i][j] && dist[i][j] < min )
			{
				min  = dist[i][j];
				v    = j;
				*len = i;							// len -       
			}										//         

	return v;
}

void dijkstra(double Lo)							//        Lo ( K = M-Lo)
{
	for(int i = 0; i <= N; i++)						//  
	{
		dist[0][i] = dist[1][i] = MAX_DIST; 
		mark[0][i] = mark[1][i] = 0;
	}

#ifdef DEBUG
		for(int i = 0; i <= N; i++)
		{
			pred[0][i]     = pred[1][i]     = 0;
			pred_log[0][i] = pred_log[1][i] = 0;
		}
#endif
	
	dist[0][0] = dist[1][0] = 0;						//    -   2  ( L  K)
	

	double L;
	int v, now_log, next_log;							// [v] - "" ; now_log: 0 - L, 1 - K [=M-Lo]; 
	int relaxes = 0, max_relaxes = 2*(N+1);				// relaxes =  "" 2*(N+1) 

	while( relaxes < max_relaxes )
	{
		v = get_min(&now_log);
		if( v == NOT_FOUND ) return;

		mark[now_log][v] = 1;										// "" [v],     'now_log' (L or K)

		if( now_log == 0 )	{ L = Lo;		next_log = 1; }			//     L (  Lo )
		else				{ L = M - Lo;	next_log = 0; }			// (   K = M-Lo )

		for(int j = 1; j <= N; j++)
			if( L >= A[v][j] )										//  ,    (now_log - L),     
			{
				if( dist[now_log][v] < dist[next_log][v] )			//      ,    (next_log - M-L)
				{
					dist[next_log][v] = dist[now_log][v];			//          (next_log - M-L)
#ifdef DEBUG
					pred[next_log][v]     = pred[now_log][v];		//      (  )
					pred_log[next_log][v] = next_log;				//      (next_log,      [ now_log])
#endif
				}
				if( !mark[next_log][j] )									//    (M-L)       (L)
					if( dist[next_log][j] > dist[now_log][v] + A[v][j] )	//      [j]   (M-L)
					{
#ifdef DEBUG
							pred[next_log][j]	  = v;						//   [j]  [v]
							pred_log[next_log][j] = now_log;				//    [v] -     (L - now_log)
#endif
						dist[next_log][j] = dist[now_log][v] + A[v][j];
					}
			}

		relaxes++;
	}

	return;
}

void main()
{
	file_read();
	fill_dist_matrix();
	lengths.unique();								//    -  ( ) 

#ifdef DEBUG
		show_matrix();
#endif
	
	double now_dist = best_dist = MAX_DIST;
	for(list<double>::iterator L_ptr = lengths.begin(); L_ptr != lengths.end(); L_ptr++)
	{
		dijkstra(*L_ptr);	//        (*L_ptr) [   M - (*L_ptr) ]

/* 
#ifdef DEBUG				//   dist[][]
			dbg << endl << " L = " << *L_ptr << " and K = " << M-(*L_ptr) << endl;
			dbg << " dist[L] : ";
			for(int i = 0; i <= N; i++)
			{
				dbg << "[" << i << "]-";
				dbg.width(8);
				if( dist[0][i] == MAX_DIST )	dbg << "MAX  ";
				else							dbg << dist[0][i] << "  ";
			}
			dbg << endl << " dist[K] : ";
			for(int i = 0; i <= N; i++) 
			{
				dbg << "[" << i << "]-";
				dbg.width(8);
				if( dist[1][i] == MAX_DIST )	dbg << "MAX  ";
				else							dbg << dist[1][i] << "  ";
			}
			dbg << endl;
#endif 
*/

		now_dist = min(dist[0][N], dist[1][N]);

#ifdef DEBUG									//       (   ) 
			if( now_dist != MAX_DIST )
				if( now_dist <= best_dist )
				{
					if( dist[0][N] <= dist[1][N] )
					{
						dbg << endl;
						dbg << dist[0][N] << " (m) way with logs L = " << *L_ptr << " and K = " << M-(*L_ptr) << endl;
						write_path(N, 0);
					}
					if( dist[0][N] >= dist[1][N] )
					{
						dbg << endl;
						dbg << dist[1][N] << " (m) way with logs L = " << *L_ptr << " and K = " << M-(*L_ptr) << endl;
						write_path(N, 1);
					}
					dbg << endl;
				}
#endif

		if( now_dist < best_dist )
		{
			best_dist = now_dist;
			best_L	  = *L_ptr;
		}
	}

	if( best_dist == MAX_DIST ) out << "Unreachable" << endl;
	else						out << best_dist << " " << best_L << " " << M - best_L << endl;
}